#define D(x) {if (debug_file && debug_level){x;fflush(debug_file);}}
#define D0(x) {if (debug_file){x;fflush(debug_file);}}
#define D1(x) {if (debug_file && (debug_level > 0)){x;fflush(debug_file);}}
#define D2(x) {if (debug_file && (debug_level > 1)){x;fflush(debug_file);}}
#define D3(x) {if (debug_file && (debug_level > 2)){x;fflush(debug_file);}}
#define D4(x) {if (debug_file && (debug_level > 3)){x;fflush(debug_file);}}
#define D5(x) {if (debug_file && (debug_level > 4)){x;fflush(debug_file);}}
#define D6(x) {if (debug_file && (debug_level > 5)){x;fflush(debug_file);}}

//#define DD(x)
#define DD(x)  {if (debug_file){fprintf(debug_file,"%s:%d:",__FILE__,__LINE__);x;fflush(debug_file);}}
// HEADER_SIZE is defined to be larger than actual header (later - with EXIF)  to use compile-time buffer
#define JPEG_HEADER_MAXSIZE    0x300 // will not change

#include <asm/elphel/exifa.h>

typedef struct {
  int                   segment_duration;
  int                   segment_length;
  int                   save_gp; //if non zero, current circbuf pointer will be saved to global pointer, so imgsrv can report /pointers
  char                  path_prefix[256];
  char                  path[300];
  int                   cirbuf_rp; //!-1 - invalid
  int                   fd_circ;   //! file descriptor for circbuf
  int                   fd_head;   //! file descriptor for JPEG header
//  int                   fd_sens;   //! file descriptor for sensor/compressor parameters
  int                   fd_fparmsall;   //! file descriptor for sensor/compressor parameters
  int                   fd_exif;   //! file descriptor for Exif data
  int                   head_size; //! JPEG header size
  char                  jpegHeader [JPEG_HEADER_MAXSIZE];
  int                   metadata_start;
  struct interframe_params_t frame_params;
  struct interframe_params_t this_frame_params;
  int                   jpeg_len;
  int                   frame_period ; //!in microseconds (1/10 of what is needed for the Ogm header)
  int                   width;
  int                   height;
  int                   starting;
  int                   running;
  int                   last_error_code;
  ogg_stream_state      os;
  ogg_page              og;
  ogg_packet            op;
  elph_ogg_packet       eop;
  int                   serialno;
  ogg_int64_t           packetno;
  ogg_int64_t           granulepos;
  FILE*                 vf; //! video file (ogm, fopen)
  int                   ivf; //! video file (jpeg, mov - open)
  int                   last; //last packet in a file

  int                   exif; // 1 - calculate and include Exif headers in each frame
//  exif_pointers_t       ep;
//  int                   exifValid;
  int                   exifSize; //signed
  unsigned char         ed[MAX_EXIF_SIZE];

  int                   circ_buff_size;
  int                   senspars_size;
  char                  debug_name[256];
//  FILE*             debug_file;
  int                   set_samples_per_unit;
  double                timescale; //! current timescale, default 1.0
  double                set_timescale;
  double                start_after_timestamp; /// delay recording start to after frame timestamp
  int                   max_frames;
  int                   set_max_frames;
  int                   frames_per_chunk;
  int                   set_frames_per_chunk; // quicktime -  index for fast forward?
  int                   frameno;
  int*                  frame_lengths;
  off_t                 frame_data_start; //! Quicktime (and else?) - frame data start (0xff 0xd8...) 
  ogg_int64_t           time_unit;
  int                   formats;          //! bitmask of used (initialized) formats
  int                   format;           //! output file format
  int                   set_format;       //! output format to set (will be updated after stop)
  elph_packet_chunk     packetchunks[7];
  int                   chunk_index;
  int                   buf_overruns;
  int                   buf_min;
  int                   set_frames_skip;  //! will be copied to frames_skip if stopped or at start
  int                   frames_skip;      //! number of frames to skip after the one recorded (for time lapse)
                                          //! if negetive - -(interval between frames in seconds)
  int                   frames_skip_left; //! number of frames left to skip before the next one to be processed
                                          //! if (frames_skip <0) - next timestamp to save an image
//kml stuff
  int                   kml_enable;       //! enable KML file generation
  int                   kml_used;         //! KML file generation used (change only when stopped)
  char                  kml_path[300];    //! full path for KML file (if any)
  FILE*                 kml_file;         //! stream to write kml file
  double                kml_horHalfFov;   //! half horizontal Fov (degrees)
  double                kml_vertHalfFov;  //! half vertical Fov (degrees)
  double                kml_near;         //! Use in KML "near" parameter (<=0 - don't use it)
  int                   kml_height_mode;  //! 1 - actual, 0 - ground
  double                kml_height;       //! extra height to add
  int                   kml_period;       //! generate PhotoOverlay for each kml_period seconds;
  int                   kml_last_ts;      //! last generated kml file timestamp
  int                   kml_last_uts;     //! last generated kml file timestamp, microseconds
  struct exif_dir_table_t kml_exif[ExifKmlNumber] ;  //! store locations of the fields needed for KML generations in the Exif block
   

} camogm_state;

extern int   debug_level;
extern camogm_state * state;
void put_uint16(void *buf, u_int16_t val);
void put_uint32(void *buf, u_int32_t val);
void put_uint64(void *buf, u_int64_t val);
unsigned long getGPValue(unsigned long GPNumber);
void setGValue(unsigned long  GNumber,   unsigned long value);
