#!/usr/local/sbin/php -q
<?php
/*!
*! PHP script
*! FILE NAME  : ccamftp.php
*! DESCRIPTION: daemon for periodic upload images to the remote ftp server
*! AUTHOR     : Elphel, Inc.
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: ccamftp.php,v $
*!  Revision 1.4  2009/06/08 22:50:30  elphel
*!  disabled debug log
*!
*!  Revision 1.3  2009/06/08 22:46:19  elphel
*!  Fixed couple bugs, added debug notes
*!
*!  Revision 1.2  2008/12/08 08:16:01  elphel
*!  bug fixes + made ccamftp.php work with launch_php_script.php. Only minor change will be needed to fully control ccamftp.php from camvc
*!
*!  Revision 1.1.1.1  2008/11/27 20:04:02  elphel
*!
*!
*!  Revision 1.2  2008/11/22 20:08:24  elphel
*!  removed time limit on the execution of the script
*!
*!  Revision 1.1  2008/11/22 06:01:11  elphel
*!  working on ccamftp.php
*!
*!
*/
/*! Notess for debugging (to get error output to console):
1) killall launch_php_script
2) /usr/local/sbin/launch_php_script 2 /usr/local/sbin/ccamftp.php
(or even just /usr/local/sbin/ccamftp.php)
*/
///
/// this script may run for months and years ...
///
set_time_limit(0);
$ftpConfigFile='/etc/conf.d/ccamftp.conf';
$tmpDir=       '/tmp';
$daemonParamsTemplate=array('FTP_PERIOD'=>null, 'FTP_TIMEOUT'=>null, 'FTP_UPDATE'=>null, 'FTP_NEXT_TIME'=>null);
//echo "<pre>";
if (!file_exists ($ftpConfigFile)) {
//DAEMON_EN_CCAMFTP
  echo "Configuration file $ftpConfigFile does not exist, exiting\n";
  $frame=elphel_set_P_arr(array('DAEMON_EN_CCAMFTP'=>0)); /// disable daemon_bit;
  elphel_wait_frame_abs($frame) ;/// wait for that frame before giving control back to launch_php_script (prevent re-starting)
  exit (1);
}
  $lastCycleTime=0; /// timestamp of last uploaded image
/// Main loop
/// To save memory usage make this daemon exit if it was not enabled at boot time (so starting needs reboot, not just enabling)
  if (elphel_get_P_value(ELPHEL_DAEMON_EN_CCAMFTP)==0) exit (0); /// just in case - should not be launched
  elphel_set_P_value(ELPHEL_FTP_NEXT_TIME, time()); /// G_parameter, valid for reading immediately
  while (true) { /// read configuration file (local, in /etc/conf.d)
    $ftpConfig=parse_ini_file  ($ftpConfigFile );
      if ($ftpConfig['ENABLE']==0) { /// disabled in the configuration file (ENABLE=0)
      echo "Configuration file $ftpConfigFile has a line \"ENABLE=0\", exiting \n";
      $frame=elphel_set_P_arr(array('DAEMON_EN_CCAMFTP'=>0)); /// disable daemon_bit;
      elphel_wait_frame_abs($frame) ;/// wait for that frame before giving control back to launch_php_script (prevent re-starting)
      exit (1); ///
    }
    $tmpJPEG=$tmpDir."/".$ftpConfig['INAME'].".jpeg";
/// See if daemon was not disabled
    if (elphel_get_P_value(ELPHEL_DAEMON_EN_CCAMFTP)==0) exit (0); /// exit. Will be re-launced by launch_php_script if enabled
    $daemonParams=elphel_get_P_arr($daemonParamsTemplate);
//debug_log(__LINE__.":tmpJPEG=$tmpJPEG\ndaemonParams=".serialize($daemonParams)."\n");
//   print_r($daemonParams);
/// Try to read the new config file from the remote server, using timeouts. Remote config may be used to change camera parameters
/// in case there is no direct remote access to the camera
    $remoteConfig=    getFTPFileWithTimeoutTo($ftpConfig['SERVER'],
                                                $ftpConfig['USER'],
                                            $ftpConfig['PASSWORD'],
                                     $ftpConfig['REMOTE_CONF_DIR'],
                                               $ftpConfig['INAME'],
                                                           $tmpDir,
                                      $daemonParams['FTP_TIMEOUT']);

/// Apply received parameters if any
    if ($remoteConfig) {
      foreach ($remoteConfig as $key=>$value) $remoteConfig[$key]=myval($value);
       $frameWritten=elphel_set_P_arr($remoteConfig); ///  frame to which parameters apply;
       $daemonParams=elphel_get_P_arr($daemonParamsTemplate,$frameWritten);
       elphel_wait_frame_abs($frameWritten+2); /// so image will be new
    }
/// Is it a time to acquire a new image?
/// Not yet - sleep and restart the cycle
    if ((($dt=($daemonParams['FTP_NEXT_TIME']-time())))>0) {
       if ($dt>$daemonParams['FTP_UPDATE']) $dt=$daemonParams['FTP_UPDATE'];
       sleep ($dt);
    } else { /// Get and FTP image to the remote server
      if (file_exists($tmpJPEG)) unlink ($tmpJPEG);
      copy ('http://127.0.0.1:8081/img',$tmpJPEG);
//    exec ("wget http://127.0.0.1:8081/bimg  -q -O ${tmpJPEG}");

      $cmd=sprintf("timeout %d sftpclient -s -p %s  -k %s -l %s -c %s -d %s.jpeg -t %s.tmp -u %s -w %s",
                    $daemonParams['FTP_TIMEOUT'],
                    $ftpConfig['SERVER'],
                    $tmpDir,
                    $tmpJPEG,
                    $ftpConfig['REMOTE_DIR'],
                    $ftpConfig['INAME'],
                    $ftpConfig['INAME'],
                    $ftpConfig['USER'],
                    $ftpConfig['PASSWORD']);
//    echo "exec $cmd \nreturned ".exec ($cmd)."\n";
      exec ($cmd);

/// Now execute remote script if it exists:
      if ($ftpConfig['REMOTE_SCRIPT_PATH']) getFileWithTimeoutTo($ftpConfig['REMOTE_SCRIPT_PATH'],
                           '/dev/null',
                           $daemonParams['FTP_TIMEOUT']);
/// try maintaining fixed period
      $daemonParams['FTP_NEXT_TIME']+=$daemonParams['FTP_PERIOD'];
      if ($daemonParams['FTP_NEXT_TIME'] < time()) { /// no, already missed next time due - just add period to this time
         $daemonParams['FTP_NEXT_TIME']=time()+$daemonParams['FTP_PERIOD'];
      }
      elphel_set_P_value(ELPHEL_FTP_NEXT_TIME, $daemonParams['FTP_NEXT_TIME']); /// G_parameter, valid for reading immediately
    }
  }


  function getFTPFileWithTimeoutTo($server,$user,$password,$remoteConfDir,$iname,$tmpDir,$timeout) {
    $tmpName="${tmpDir}/${iname}.conf";
    getFileWithTimeoutTo("ftp://${user}:${password}@${server}/${remoteConfDir}/${iname}.conf",$tmpName, $timeout);
/// See if it was a success
    if (!file_exists($tmpName)) return null; /// no file at all
    $remoteConfig=parse_ini_file  ($tmpName);
//print_r ($remoteConfig);
    if ($remoteConfig['FINISH']==1) {
      unset ($remoteConfig['FINISH']);
      return $remoteConfig;
    }
    return null;

  }
  function getFileWithTimeoutTo($url,$tmpName,$timeout) {
    /// delete if exists and not /dev/*
//debug_log(__LINE__.'url='.$url."\n");
    if ((file_exists($tmpName)) && (strpos($tmpName,'/dev/'!==0))) unlink ($tmpName);
    $cmd="timeout ${timeout} wget \"${url}\"  -q -O ${tmpName}";
//    echo "exec $cmd \nreturned ".exec ($cmd)."\n";
    exec ($cmd);
  }
function myval ($s) {
  $s=trim($s,"\" ");
  if (strtoupper(substr($s,0,2))=="0X")   return intval(hexdec($s));
  else return intval($s);
}

function debug_log($str) {
  $log_file="/var/log/ccamftp.log";
  $log=fopen($log_file,"a+");
  fprintf($log,$str);
  fclose ($log);
}

?>
