#include <fcntl.h>  /*open*/
#include <unistd.h> /* close, sleep */
#include <stdio.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <sys/mman.h>		/* mmap */
#include <string.h> // memcpy


#include <asm/elphel/c313a.h>

//#define D0(x) printf("%s:%d:",__FILE__,__LINE__);x
#define D0(x)
//#define GLOBALPARS(x) globalPars[(x)-FRAMEPAR_GLOBALS] // should work in drivers and applications defined in c313a.h

//#define MAP_OPTIONS MAP_FILE|MAP_PRIVATE //Eeeks
#define MAP_OPTIONS MAP_SHARED
int main (int argc, char *argv[]) {
 const char BuffFileName[]="/dev/circbuf";
// const char HeadFileName[]="/dev/jpeghead";
 const char ctlFileName[]="/dev/frameparsall";

  int buff_fd, fd_fparmsall;
  int sensor_state, compressor_state;
  int frame_number, frame8;
  int jpeg_wp, jpeg_rp;

  int buff_size;
  int i,i0, a, alen;
  unsigned long * ccam_dma_buf;				/* mmapped array */
  int jpeg_len,jpeg_start;
  int l;
  double tim;
  struct framepars_all_t   *frameParsAll;
  struct framepars_t       *framePars;
  unsigned long            *globalPars;

//  struct framepars_past_t  *pastPars;

  

    fd_fparmsall = open(ctlFileName, O_RDWR);
    if (fd_fparmsall<0) { // check control OK
       printf ("Error opening %s\n", ctlFileName);
       return -1;
    }

// Read current sensor state - defined in c313a.h
    frame_number=lseek(fd_fparmsall, 0, SEEK_CUR );
    frame8= frame_number & PARS_FRAMES_MASK;
    printf ("Current frame number is %d\n",frame_number);
//! now try to mmap
    frameParsAll = (struct framepars_all_t *) mmap(0, sizeof (struct framepars_all_t) , PROT_READ, MAP_SHARED, fd_fparmsall, 0);
    if((int)frameParsAll == -1) {
      frameParsAll=NULL;
      printf("Error in mmap /dev/frameparsall");
      close (fd_fparmsall);
      fd_fparmsall = -1;
      return -1;
    }
    framePars=  frameParsAll->framePars;
    globalPars= frameParsAll->globalPars;

    sensor_state=framePars[frame8].pars[P_SENSOR_RUN];
    printf ("Sensor state is %d (%s)\n",sensor_state, (sensor_state==0)?"SENSOR_RUN_STOP":((sensor_state==1)?"SENSOR_RUN_SINGLE":((sensor_state==2)?"SENSOR_RUN_CONT":"UNKNOWN")));

    compressor_state=framePars[frame8].pars[P_COMPRESSOR_RUN];
    printf ("Compressor state is %d (%s)\n",compressor_state, (compressor_state==0)?"COMPRESSOR_RUN_STOP":((compressor_state==1)?"COMPRESSOR_RUN_SINGLE":((compressor_state==2)?"COMPRESSOR_RUN_CONT":"UNKNOWN")));

   int circbuf_wp,circbuf_rp,circbuf_size,circbuf_free;
///These are read from frame zero (they are not frame-related)
   circbuf_wp=GLOBALPARS(G_CIRCBUFWP);
   circbuf_rp=GLOBALPARS(G_CIRCBUFRP);
   circbuf_size=GLOBALPARS(G_CIRCBUFSIZE);
   circbuf_free=GLOBALPARS(G_FREECIRCBUF);
   printf("circbuf_size=0x%08x (0x%08x)\n",circbuf_size, circbuf_size>>2);
   printf("circbuf_wp=  0x%08x (0x%08x)\n",circbuf_wp,   circbuf_wp>>2);
   printf("circbuf_rp=  0x%08x (0x%08x)\n",circbuf_rp,   circbuf_rp>>2);
   printf("circbuf_free=0x%08x (0x%08x)\n",circbuf_free, circbuf_free>>2);
   jpeg_wp= circbuf_wp>>2;
   printf ("Write pointer was 0x%x\n",jpeg_wp);
   close(fd_fparmsall);

//! now open circbuf
    buff_fd = open(BuffFileName, O_RDWR);
    if (buff_fd<0) { // check control OK
       printf ("Error opening %s\n", BuffFileName);
       return -1;
    }
#if 0
#define LSEEK_CIRC_TORP  1
#define LSEEK_CIRC_TOWP  2
#define LSEEK_CIRC_PREV  3
#define LSEEK_CIRC_NEXT  4
#define LSEEK_CIRC_LAST  5
#define LSEEK_CIRC_FIRST 6
#define LSEEK_CIRC_SETP  7
#define LSEEK_CIRC_VRFY  8
#define LSEEK_CIRC_WAIT  9
#endif

// find total buffer length (it is in defines, actually in c313a.h
    buff_size=lseek(buff_fd,0,2);
    jpeg_rp=lseek(buff_fd,LSEEK_CIRC_TORP,2);
    if (jpeg_rp<0) { 
        printf ("Read pointer was invalid, recalculating\n");
        jpeg_rp=lseek(buff_fd,LSEEK_CIRC_FIRST,2);    //! read pointer was invalid - try the earliest frame available
    }
    jpeg_rp =jpeg_rp >> 2; // to words
    printf ("Circular buffer stores %d (0x%x) long values or %d (0x%x bytes), global read pointer is 0x%x\n",(buff_size>>2),(buff_size>>2),buff_size,buff_size, jpeg_rp);
// now let's try mmap itself

D0(sleep(5));
   ccam_dma_buf = (unsigned long *) mmap(0, buff_size, PROT_READ, MAP_OPTIONS, buff_fd, 0);
//   ccam_dma_buf = (unsigned long *) mmap(0, buff_size, PROT_READ, MAP_SHARED, buff_fd, 0);

   if((int)ccam_dma_buf == -1) {
     printf("Error in mmap %s\r\n",BuffFileName);
     close(buff_fd);
     return -1;
   }
// display a portion of the buffer around the jpeg_wp
   printf ("[] shows the value pointed by the last frame's DMA address pointer, <> - length of the last frame,\n" );
   alen=jpeg_wp-9; if (alen<0) alen+= (buff_size>>2);
   i0=(jpeg_wp>>3)<<3;
D0(sleep(5));
   for (i=(i0-64);i<(i0+32);i++) {
     a=i;
     if (i<0) a+=(buff_size>>2);
     else if (i>=(buff_size>>2)) a-=(buff_size>>2);
     if ((i & 7)==0) printf("\n%06x: ",a);
     if      (a==alen) printf("<%08lx>",ccam_dma_buf[a]);
     else if (a==jpeg_wp) printf("[%08lx]",ccam_dma_buf[a]);
     else                 printf(" %08lx ",ccam_dma_buf[a]);
   }
   printf("\n");
D0(sleep(5));

// let's get the last frame here
   jpeg_len=ccam_dma_buf[alen] & 0xffffff; 
   tim=ccam_dma_buf[alen-1];
   tim=ccam_dma_buf[alen-2]+(0.000001*tim);
//   jpeg_start=(alen & 0xfffffff8)- (((jpeg_len+7) & 0xffffffe0)>>2);
   jpeg_start=(alen & 0xfffffff8)- (((jpeg_len + CCAM_MMAP_META + 3) & 0xffffffe0)>>2);
   if (jpeg_start<0) jpeg_start+=(buff_size>>2);
   printf ("JPEG length=%d (0x%x)\n",jpeg_len,jpeg_len);
   printf ("timestamp=%f\n",tim);
   for (i=(jpeg_start-48);i<(jpeg_start+16);i++) {
     a=i;
     if (i<0) a+=(buff_size>>2);
     else if (i>=(buff_size>>2)) a-=(buff_size>>2);
     if ((i & 7)==0) printf("\n%06x: ",a);
     if      (a==jpeg_start) printf("{%08lx}",ccam_dma_buf[a]);
     else                 printf(" %08lx ",ccam_dma_buf[a]);
   }
   printf("\n");

   if (jpeg_rp>=0) {
   printf("\n");
     for (i=(jpeg_rp-16);i<(jpeg_rp+8);i++) {
       a=i;
       if (i<0) a+=(buff_size>>2);
       else if (i>=(buff_size>>2)) a-=(buff_size>>2);
       if ((i & 7)==0) printf("\n%06x: ",a);
       if      (a==jpeg_rp) printf("(%08lx)",ccam_dma_buf[a]);
       else                 printf(" %08lx ",ccam_dma_buf[a]);
     }
     printf("\n");
   }

D0(sleep(5));
   l= munmap(ccam_dma_buf, buff_size);
D0(sleep(5));
   printf ("munmap(0, %d) returned %d\n",buff_size,l);
D0(sleep(5));

   close (buff_fd);              
D0(sleep(5));
   return 0;
}

