/*
** -----------------------------------------------------------------------------**
** IC_DAC2900.v
**
** A simple model of the dual channel DAC for simulation of the x324 FPGA
**
** Copyright (C) 2003-2006 Elphel, Inc.
**
** -----------------------------------------------------------------------------**
**  This file is part of x324
**  x324 is free software - hardware description language (HDL) code.
** 
**  This program is free software: you can redistribute it and/or modify
**  it under the terms of the GNU General Public License as published by
**  the Free Software Foundation, either version 3 of the License, or
**  (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program.  If not, see <http://www.gnu.org/licenses/>.
** -----------------------------------------------------------------------------**
**
**  $Log: IC_DAC2900.v,v $
**  Revision 1.1.1.1  2008/11/27 20:04:02  elphel
**
**
**  Revision 1.1.1.1  2007/08/17 12:07:19  elphel
**  This is a fresh tree based on elphel353-2.10
**
**  Revision 1.6  2007/08/17 12:07:19  spectr_rain
**  switch to GPL3 license
**
**  Revision 1.5  2007/07/20 09:46:13  spectr_rain
**  *** empty log message ***
**
**  Revision 1.4  2007/05/25 02:09:09  elphel
**  347 update for mechanical shutter
**
**  Revision 1.2  2006/09/24 16:45:51  elphel
**  added real time clock
**
*/

module IC_DAC2900(DA,DB,WA,WB,LDA,LDB,QA,QB);
    input [9:0] DA;
    input [9:0] DB;
    input WA;
    input WB;
    input LDA;
    input LDB;
    output [9:0] QA;
    output [9:0] QB;

reg [9:0] dda;
reg [9:0] ddb;
reg [9:0] dqa;
reg [9:0] dqb;
assign QA=dqa;
assign QB=dqb;
always @ (posedge WA)  dda <= DA;
always @ (posedge WB)  ddb <= DB;
always @ (posedge LDA) dqa <= dda;
always @ (posedge LDB) dqb <= ddb;
endmodule
