#! /bin/sh -e
#
# (C) Copyright 2005-2007, Axis Communications AB, LUND, SWEDEN
# This file is released under the GPL v2.

if [ -f "$AXIS_TOP_DIR/.config" ]; then
	. $AXIS_TOP_DIR/.config
else
	echo "\$AXIS_TOP_DIR/.config not found" >&2
	exit 1
fi

[ "$1" ] || {
	echo "Interface name argument missing" >&2
	exit 1
}

cat <<-EOF
	# (C) Copyright 2005-2007, Axis Communications AB, LUND, SWEDEN
	# Modified by Elphel, Inc., USA
	# This file is released under the GPL v2.

EOF

if [ "$AXIS_CONFIG_PRODUCTION_TEST_FIRMWARE" = y ]; then
	cat <<-EOF
		# $1 configuration for production test firmware.

EOF
fi

[ "$AXIS_CONFIG_8021X" = y ] && {
	cat <<-EOF
		SYSTEMDEVICE=$1

EOF
}

cat <<-EOF
	# Uncomment the following line to override the generic hardware address
	# (usually the serial number) for this interface only.
	# MAC=00:0E:64:00:00:00

	# Valid boot protocols are "dhcp" and "none" (anything other than "dhcp" works).
EOF

if [ "$AXIS_CONFIG_PRODUCTION_TEST_FIRMWARE" = y ] || \
   [ "$AXIS_CONFIG_DHCP" != y ]; then
	cat <<-EOF
		BOOTPROTO=none
EOF
elif [ "$AXIS_CONFIG_DHCP" = "y" ]; then
	cat <<-EOF
		BOOTPROTO=none
EOF
fi

if [ "$AXIS_CONFIG_PRODUCTION_TEST_FIRMWARE" != y ]; then
	cat <<-EOF
	DHCP_CLIENT="/sbin/udhcpc -i $1 -H \$(hostname)"
EOF
fi

cat <<-EOF

	# Valid media types are "auto", "10baseT-HD", "10baseT-FD", "100baseTX-HD",
	# "100baseTX-FD" and "" (nothing).
	MEDIA=auto
	AUTONEG=normal

	# If you are using DHCP the following variables will not be used.
	IP=192.168.0.9
	NETMASK=255.255.255.0
	BROADCAST=192.168.0.255
	GATEWAY=192.168.0.15

	# MDI/MDIX configuration; "mdi" - for MDI (normal) ; "mdix" - for MDIX (cross); 'auto' - automatic switching
	# most computers and switches now are 'auto', and having 'auto' on both ends sometimes causes problems.
	MDI_MODE=mdi
EOF

if  [ "$AXIS_CONFIG_IPV6" = y ]; then
	cat <<-EOF

		# Values: yes|no
		INET_ENABLED=yes
		INET6_ENABLED=no
		INET6_RA=yes

		# Values: auto|stateful|stateless|off
		INET6_DHCPV6=auto

		# Manually assigned IPv6 addresses and default gateway
		INET6_IP=""
		INET6_GATEWAY=""
EOF
fi
