function makeRequest(url, parameters) {
	http_request = false;
	if (window.XMLHttpRequest) { // Mozilla, Safari,...
		http_request = new XMLHttpRequest();
		if (http_request.overrideMimeType) {
			http_request.overrideMimeType('text/xml');
		}
	} else if (window.ActiveXObject) { // IE
		try {
			http_request = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
				http_request = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e) {}
		}
	}
	if (!http_request) {
 		alert('Cannot create XMLHTTP instance');
 		return false;
	}
	http_request.open('GET', url + parameters , true);
	http_request.send(null);
	http_request.onreadystatechange  = function()
	{ 
		if (http_request.readyState == 4) {
			if (http_request.status == 200) {
				if(http_request.responseXML != null) {
					var xmldoc = http_request.responseXML;
					process_scan_devices(xmldoc);
				}
			}
		}
	}; 
}

function Save() {
	var data = 0;
	
	if (document.getElementById('EN_CFM').checked)	
		data += 4;
	if (document.getElementById('EN_CFS').checked)
		data += 8;
	if (document.getElementById('EN_SATA').checked)
		data += 16;
	if (document.getElementById('SATA_MASTER').checked)
		data += 32;
	if (!document.getElementById('SATA_SPREAD').checked)
		data += 64;

	var hex_data = data.toString(16);
	
	//alert (hex_data); //debug
	
	makeRequest('http://' + location.host + '/i2c.php', '?bus=1&raw=0x2000&data=0x' + hex_data);

	setTimeout('redirect()', 1000);
}

function redirect() {
	window.location = "http://" + location.host + "/camerasetup/setup.php?page=10369";
}

function Reboot() {
	makeRequest('10369_interface.php', '?command=reboot');

	//window.location = "http://" + location.host + "/camerasetup/setup.php?page=10369";
}

function scan_devices() {
	makeRequest('../camogmgui/camogm_interface.php', '?cmd=listdevices');	
}

function process_scan_devices(xmldoc) {			
	if (xmldoc.getElementsByTagName('listdevices').length > 0) {
		var content = "";
		content += "<table cellpadding='10' cellspacing='0' cellmargin='0'>";
		content += "<tr><td></td><td><b>Partition</b></td><td><b>Mountpoint</b></td><td><b>Size</b></td><td><b>Filesystem</b></td><td></td></tr>";
		for (var i=0; i < xmldoc.getElementsByTagName('item').length; i++) {
			if (xmldoc.getElementsByTagName('item')[i].firstChild.firstChild.data != null) {
				if (xmldoc.getElementsByTagName('item')[i].getElementsByTagName('mountpoint')[0].firstChild.data == "none") {
					content += "<tr><td></td><td>" + xmldoc.getElementsByTagName('partition')[i].firstChild.data + "</td><td><input id='mount_point' size='8' type='text'";
					if(xmldoc.getElementsByTagName('partition')[i].firstChild.data == "/dev/hda1")
						content += " value='/var/hdd'";
					content += "></td><td>" + xmldoc.getElementsByTagName('size')[i].firstChild.data + "</td><td>" + '</td><td><a href="#" onClick="mount_custom_partition(\'' + xmldoc.getElementsByTagName('partition')[i].firstChild.data + '\');">mount</a></td></tr>';
				}
				else {
					content += "<tr><td><img alt=\"HDD\" src=\"images/hdd.png\"></td><td>" + xmldoc.getElementsByTagName('partition')[i].firstChild.data;
					content += "</td><td>" + xmldoc.getElementsByTagName('mountpoint')[i].firstChild.data + "</td><td>";
					content += xmldoc.getElementsByTagName('size')[i].firstChild.data + "</td><td>" + xmldoc.getElementsByTagName('filesystem')[i].firstChild.data;
					content += "</td><td><a href=\"../admin-bin/editcgi.cgi?file=" + xmldoc.getElementsByTagName('mountpoint')[i].firstChild.data + "\">Browse</a>";
					content += ' | <a href="#" onClick="unmount_custom_partition(\'' + xmldoc.getElementsByTagName('mountpoint')[i].firstChild.data + '\');">Unmount</a></td></tr>';	
				}
			}
		}
		content += "</table>";
		document.getElementById('ajax_devices').innerHTML = content;
	}
}

function init () {
	scan_devices();	
}

window.onload = init;

function mount_custom_partition(partition) {
	if (document.getElementById("mount_point").value != "") {
		makeRequest('../camogmgui/camogm_interface.php', '?cmd=mount&partition=' + partition + '&mountpoint=' + document.getElementById("mount_point").value);
		setTimeout('scan_devices()', 1000);
	}
}

function unmount_custom_partition(mountpoint) {
	if (mountpoint != "") {
		makeRequest('../camogmgui/camogm_interface.php', '?cmd=umount&mountpoint=' + mountpoint);
		setTimeout('scan_devices()', 1000);
	}
}






