<?php
/*!*******************************************************************************
*! FILE NAME  : gamma-curve.php
*! DESCRIPTION: Reads gamma table values and displays them in a nice graph.
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!
*!
*!
*/
?>
<html>
<head>
	<TITLE>Gamma Curve</TITLE>
	<script type="text/javascript" src="wz_jsgraphics.js"></script>
</head>
<body style="background-color:#000; color:#fff; padding:0; margin:0;">
<?php
// get the number (page) of the table currently in use from gamma cache
$gammas_file = fopen("/dev/gamma_cache","r");
fseek($gammas_file,0,SEEK_END);
$numberOfEntries = ftell($gammas_file);
fclose($gammas_file);
$gammaStructure = array();
$g_raw = elphel_gamma_get_raw(0);
$g_raw_ul = unpack('V*',$g_raw);
$gammaStructure["num_locked"] = $g_raw_ul[10];
$gammaStructure["locked_col"] =  array ($g_raw_ul[11],$g_raw_ul[12],$g_raw_ul[13],$g_raw_ul[14]);

$page = $gammaStructure["locked_col"][0];

// read gamma table from the page we just got
$g_raw = elphel_gamma_get_raw($page);
$g_raw_ul = unpack('V*',$g_raw);
$a = 11; // skip all the header bits and just start where the gamma table begins

for ($i=0; $i<128; $i++) {
	$d = $g_raw_ul[$a++];
	$Y[$i*2] = 256-(int)(($d & 0xffff)/256);
	$Y[$i*2+1] = 256-(int)((($d>>16) & 0xffff)/256);
}

?>
<div id="gamma_table" style="position:relative;height:512px;width:512px;background-color:#444;border:1px solid #666;margin:20px;"></div>
<script type="text/javascript">
<!--
var cnv = document.getElementById("gamma_table");
var jg = new jsGraphics(cnv);
jg.setColor("#fff");
jg.setStroke(2);
<?
// draw 256 short lines that form the curve
for ($j = 0; $j < 255; $j++) {
	$X1 = $j*2;
	$X2 = $j*2+1;
	$Y1 = $Y[$j]*2;
	$Y2 = $Y[$j+1]*2;
	echo "jg.drawLine($X1, $Y1, $X2, $Y2);\n";
}
?>
// draw horizontal and vertical guide lines
jg.setColor("#222");
jg.setStroke(Stroke.DOTTED);
jg.drawLine(128, 0, 128, 512);
jg.drawLine(256, 0, 256, 512);
jg.drawLine(384, 0, 384, 512);
jg.drawLine(0, 128, 512, 128);
jg.drawLine(0, 256, 512, 256);
jg.drawLine(0, 384, 512, 384);

// draw text
jg.setColor("#999");
jg.setFont("arial","9px");
jg.drawString("0,0",4,498);
jg.drawString("256",2,2);
jg.drawString("65536",485,500);

jg.setColor("#fff");
jg.drawString("16bit",258,500);
jg.drawString("8bit",2,246);

<?
$color;
echo "jg.setStroke(5);\n";
// draw gradients
for ($a = 0; $a < 256; $a++) {
	if ($a <16)
		$color = "#0".dechex($a)."0".dechex($a)."0".dechex($a);
	else
		$color = "#".dechex($a).dechex($a).dechex($a);
	echo "jg.setColor(\"$color\");\n";
	$gY1 = 512 - $a*2 - 1;
	$gY2 = $gY1 - 2;
	echo "jg.drawLine(-8, $gY1, -8, $gY2);\n";
}
for ($a = 0; $a < 256; $a++) {
	if ($a <16)
		$color = "#0".dechex($a)."0".dechex($a)."0".dechex($a);
	else
		$color = "#".dechex($a).dechex($a).dechex($a);
	echo "jg.setColor(\"$color\");\n";
	$gX1 = $a*2 - 1;
	$gX2 = $gX1 - 2;
	echo "jg.drawLine($gX1, 515, $gX2, 515);\n";
}
?>

jg.paint();
//-->
</script> 
</body>
</html>

