<?php
/*!***************************************************************************
*! FILE NAME  : power347.php
*! DESCRIPTION: Controls triggering of 10347 CCD timing board
*! Copyright (C) 2007 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: power347.php,v $
*!  Revision 1.1.1.1  2008/11/27 20:04:03  elphel
*!
*!
*!  Revision 1.1  2007/12/06 19:02:52  elphel
*!  collected most of the camera PHP script into one  /packages/web/353/php_top directory
*!
*!  Revision 1.1  2007/10/12 23:00:45  elphel
*!  adding power347.php to control power supplies and power timeout (supporting new FPGA interface)
*!
*!  Revision 1.1  2007/10/11 06:43:56  elphel
*!  Added two small PHP scripts to controll compressor (all sensors) and trigger (CCD with 10347 board only)
*!
*!
*/


//slow version of functions - they will reopen i2c for each word
function send347($register_address,$d0=0) {
   $i2c  = fopen('/dev/xi2c16', 'w');
   fseek ($i2c, 0x2000+2*$register_address) ; //Micron sensor slave 0xba
   fwrite($i2c, chr (floor($d0/256)).chr ($d0-256*floor($d0/256)));
   fclose($i2c);
}

 $good=TRUE;
 $data= 0;
 $timeout=$_GET['timeout'];
//! set 16-bit timeout value in ms (65535 - no timeout)
 if ($timeout != "") {
 if (($timeout=="off") || ($timeout=="off")) $timeout=0;
    if (!is_numeric($timeout)) $good=FALSE;
    else {
     $timeout=intval(1000*$timeout);
     if ( ($timeout==0) || ($timeout >= 65535)) $timeout = 65535;
     send347(0x80,$timeout);
    }
 }
//! enable/disable power. if enabled, will slowly start (PWM) at first trigger, will clean CCD - long delay
 switch  ($_GET['pwr']) {
  case "":break;
  case "dis":
  case "off":
     $data|=0x2;
     break;
  case "en":
  case "on":
     $data|=0x3;
     break;
  default:$good=FALSE;
 }

//!enable/disable shutter power (saves some 0.5W at idle)

 switch  ($_GET['shtr']) {
  case "":break;
  case "dis":$data|=0x8; break;
  case "en": $data|=0xc; break;
  default:$good=FALSE;
 }
 if (($good != FALSE) && ($data != 0)) 
   send347(0x10,$data);
 else if (! is_numeric($timeout))
  echo <<<USAGE
   <p>This script controls powering parts of the camera modules controlled by the 10347 CCD timing board:</p>
   <ul>
    <li><b>pwr=en</b> -     enables analog power supplies turning on when image acuisition is triggered (subject to timeout)</li>
    <li><b>pwr=dis</b> -    disables analog power ( and turns off at once)</li>
    <li><b>shtr=en</b> -    enable mechanical shutter power (to be controlled by sequencer)</li>
    <li><b>shtr=dis</b> -   enable mechanical shutter power (to be controlled by sequencer)</li>
    <li><b>timeout=off</b> -   analog power will stay on indefinitely</li>
    <li><b>timeout=<i>ttt</i></b> -   analog power will stay on for <i>ttt</i> seconds after exposure</li>
  </ul>
USAGE;


?>
