<?php
/*!*******************************************************************************
*! FILE NAME  : readparameter_demo.php
*! DESCRIPTION: demo script showing how to read parameters from the camera 
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*/

// display current camera exposure time in (µs / 1000 = ms);
echo "<b>Exposure Time: </b>".elphel_get_P_value(ELPHEL_EXPOS)/1000 ." ms<br/>";

// display current camera window of interest width (in pixels);
echo "<b>Image Width: </b>".elphel_get_P_value(ELPHEL_WOI_WIDTH)."<br/>";

// display current camera window of interest height (in pixels);
echo "<b>Image Height: </b>".elphel_get_P_value(ELPHEL_WOI_HEIGHT)."<br/>";

// reading array of parameters in a single call (faster if you need many of them).
// First -create array of parameters to read (any integer values, will be overwritten anyway)
   $WOI_arr=array(    'WOI_WIDTH' => 0,
                      'WOI_HEIGHT'=> 0,
                      'WOI_LEFT'  => 0,
                      'WOI_TOP'   => 0,
                      'DCM_HOR'   => 1,
                      'DCM_VERT'  => 1,
                      'BIN_HOR'   => 1,
                      'BIN_VERT'  => 1);
// Use $WOI_arr as a template, overwrite it with the current parameters
   $WOI_arr=elphel_get_P_arr($WOI_arr);
echo "<b>WOI parameters: </b> <pre>";
print_r($WOI_arr);
echo "</pre>";



?>
