<?php 
//! Should run only on one camera !!!

function fpga_read($addr) {
       $fpga  = fopen('/dev/fpgaio', 'r');
       fseek ($fpga, $addr) ; // 32-bit registers
       $d = fread($fpga, 4);
       fclose($fpga);
       $regs=unpack('V*',$d); // unsigned long, little endian
       return $regs[1];
     }
function fpga_write($addr,$data) {
       $fpga  = fopen('/dev/fpgaio', 'w');
       fseek ($fpga, $addr) ; // 32-bit registers
       fwrite($fpga, chr($data & 0xff).chr(($data>>8) & 0xff).chr(($data>>16) & 0xff).chr(($data>>24) & 0xff));
       fclose($fpga);
    }

function sendi2c16($register_address,$d0=0) {
   $i2c  = fopen('/dev/xi2c16', 'w');
   fseek ($i2c, 2*$register_address) ; //Micron sensor slave 0xba
   fwrite($i2c, chr (floor($d0/256)).chr ($d0-256*floor($d0/256)));
   fclose($i2c);
}

function i2cread16 ($start,$length=256) {
   $i2c  = fopen('/dev/xi2c16', 'r');
   fseek ($i2c, 2*$start) ; // 16-bit registers
   $data = fread($i2c, 2*$length);
   fclose($i2c);
   $regs=unpack('n*',$data);
//   print_r($regs);
   echo "<table>\n";
   for ($i=0; $i<$length; $i+=16){
     printf("<tr><td>%x</td>",$i);
     for ($j=1; $j<17; $j++){
       printf("<td>%x</td>",$regs[$i+$j]);
     }
     echo "</tr>\n";
   }
   echo "</table>\n";
}

 $sensorClock=96000000;
 $period=$_GET['period'];
 $fps=$_GET['fps'];
 $out=$_GET['out'];
 if ($period && is_numeric ($period)) $period=$period+0;
 else $period=1;// single trigger

 if ($fps && is_numeric ($fps))   $fps=$fps+0;
 if ($fps>0) $period= $sensorClock/$fps;

 if ($out && is_numeric ($out)) $out=$out+0;
 else $out=0xb00000; // 2 MSBs,complimetry
 fpga_write(0x70, 0xc000000);
// set output

 fpga_write(0x7a, $out);

//set period

 fpga_write(0x7b, $period);

?> 
