#!/bin/bash
## file: target_make_list.sh
##  This program is free software: you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation, either version 3 of the License, or
##  (at your option) any later version.
##
##  This program is distributed in the hope that it will be useful,
##  but WITHOUT ANY WARRANTY; without even the implied warranty of
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##  GNU General Public License for more details.
##
##  You should have received a copy of the GNU General Public License
##  along with this program.  If not, see <http://www.gnu.org/licenses/>.

## Analyzes romfs_meta.txt (created by make install in packages/romfs_meta/common)
## looking for "Ignore:file" (will not be installed) and  "Ignore:file" (will be installed, but not considered for the target.list)
## creatas target.list removing all files/directories that match.

## "shopt -s extglob" should be before function!
shopt -s extglob
recurse () {
local i
local IGNORES
if [ -f $1/$2romfs_meta.txt ] ; then
  IGNORES=`grep  "Ignore" $1/$2romfs_meta.txt | sed -e 's/Ignore://'`
else
  IGNORES=""
fi
IGNORES=`echo $IGNORES | sed -e 's/ /|/g'`
local FILES=(`ls $1/$2`)
##iterate regular files
for (( i = 0 ; i < ${#FILES[@]} ; i = i + 1 ))
do
  if [ ! -d $1/$2${FILES[$i]} ] ; then
    case ${FILES[$i]} in
            @($IGNORES) ) ;;
            *)
            case -${FILES[$i]} in
              @($IGNORES) ) ;;
              *)
             TARGETLIST="$TARGETLIST $2${FILES[$i]}"
             ;;
           esac
           ;;
    esac
  fi
done
##iterate directories, recurse
for (( i = 0 ; i < ${#FILES[@]} ; i = i + 1 ))
do
  if [ -d $1/$2${FILES[$i]} ] ; then
    case ${FILES[$i]} in
            @($IGNORES) ) ;;
            *)
            case -${FILES[$i]} in
              @($IGNORES) ) ;;
              *)
              recurse $1  $2${FILES[$i]}/
#             TARGETLIST="$TARGETLIST $1/${FILES[$i]}"
             ;;
           esac
           ;;
    esac
  fi
done
}
TARGETLIST=""
recurse $*
TARGETLIST=($TARGETLIST)
for (( i = 0 ; i < ${#TARGETLIST[@]} ; i = i + 1 ))
do
 echo ${TARGETLIST[$i]}
done
